/*
Warning: PLEASE DO NOT REMOVE THIS COMMENT WHEN REDISTRIBUTING!
This is the second official release of the Phi-prompt TUI (text user interface), library version 20110523
Released for Phi-1 and Phi-2 shields for Arduino
User is encouraged to obtain a Phi shield or is solely responsible for converting it to work on other shields or configurations.

Programmed by Dr. John Liu
Revision: 05/23/2011
Free software for educational and personal uses.
No warrantee!
Commercial use without authorization is prohibited.

Obtain the documentation or find details of the phi_prompt TUI library, Phi-1 shield, Phi-2 shield, and Phi-prompt or contact Dr. Liu at
http://liudr.wordpress.com/phi-1-shield/
http://liudr.wordpress.com/phi-2-shield/
http://liudr.wordpress.com/phi_prompt/
All rights reserved.
*/

/*
.______    __    __   __        .______   .______        ______   .___  ___. .______   .___________.
|   _  \  |  |  |  | |  |       |   _  \  |   _  \      /  __  \  |   \/   | |   _  \  |           |
|  |_)  | |  |__|  | |  |       |  |_)  | |  |_)  |    |  |  |  | |  \  /  | |  |_)  | `---|  |----`
|   ___/  |   __   | |  |       |   ___/  |      /     |  |  |  | |  |\/|  | |   ___/      |  |     
|  |      |  |  |  | |  |       |  |      |  |\  \----.|  `--'  | |  |  |  | |  |          |  |     
| _|      |__|  |__| |__|  _____| _|      | _| `._____| \______/  |__|  |__| | _|          |__|     

 _______  .______                 __       __   __    __  
|       \ |   _  \               |  |     |  | |  |  |  | 
|  .--.  ||  |_)  |              |  |     |  | |  |  |  | 
|  |  |  ||      /               |  |     |  | |  |  |  | 
|  '--'  ||  |\  \----.    __    |  `----.|  | |  `--'  | 
|_______/ | _| `._____|   (__)   |_______||__|  \______/  

http://liudr.wordpress.com
*/

//The following are switches to certain functions. Comment them out if you don't want a particular function to save program space for larger projects
#define scrolling // This turns on auto strolling on list items and includes scrolling text library function.

#define phi_prompt_arrow_dot B00000001
#define phi_prompt_index_list B00000010
#define phi_prompt_current_total B00000100
#define phi_prompt_auto_scroll B00001000
#define phi_prompt_flash_cursor B00010000
#define phi_prompt_center_choice B00100000
#define phi_prompt_scroll_bar B01000000
#define phi_prompt_invert_text B10000000

#include <WProgram.h>
#include <LiquidCrystal.h>
#include <avr/pgmspace.h>
#include <phi_buttons.h>
#define lcd_width 16

union buffer_pointer
{
int *i_buffer;
float * f_buffer;
char ** list;
char* msg;
PGM_P msg_P;
};

union four_bytes
{
int i;
long l;
float f;
byte b;
char c;
char c_arr[4];
};

struct phi_prompt_struct
{
  buffer_pointer ptr;
  four_bytes low; // Lower limit for text panel (.c), integers (.i) and floats (.f) and first item displayed + highlighted item for list (.i), say 102 means first item displayed on screen is item 1 and highlighted item is 2, both starting from 0.
  four_bytes high; // Upper limit for text panel (.c), integers (.i) and floats (.f) and last item for list (.i)
  four_bytes step;// Step size for integers (.i) and integer/decimal for floats (.i), such as 302 means 3 digits before decimal and 2 digits after.
  byte col; // Which column to display input
  byte row; // Which row to display input
  byte width; // Maximal number of character on integers, floats, a list item, and total allowed input characters for text panel
  int option; // What display options to choose
  void (*update_function)(phi_prompt_struct *); // This is not being used in this version but reserved for future releases.
}; //22 bytes

void init_phi_prompt(LiquidCrystal *l, phi_buttons ** b, int w, int h, char i);
void set_indicator(char i);
char inc(char ch, phi_prompt_struct *para);
char dec(char ch, phi_prompt_struct *para);
void scroll_text(char * src, char * dst, char dst_len, short pos);
void scroll_text_P(PGM_P src, char * dst, char dst_len, short pos);
void msg_lcd(char* msg_lined);
void center_text(char * src);
void scroll_bar_v(byte p, byte c, byte r, byte h);
void long_msg_lcd(phi_prompt_struct *para);
void long_msg_lcd_P(phi_prompt_struct *para);
byte render_list(phi_prompt_struct *para);

int wait_on_escape(int ref_time); // Returns key pressed or 0 if time expires before any key was pressed.

int ok_dialog(char msg[]); // Displays an ok dialog
int yn_dialog(char msg[]); // Displays a yes/no dialog
int input_integer(phi_prompt_struct *para); //Display options for integers:0: space pad right, 1: zero pad left, 2: space pad left.
int input_float(phi_prompt_struct *para);
int select_list(phi_prompt_struct *para); //Display options for list: Option 0, display classic list, option 1, display 2X2 list, option 2, display list with index, option 3, display list with index2.
int input_panel(phi_prompt_struct *para); //Input character options for input panel: Option 0, default, option 1 include 0-9 as valid inputs.
int text_area(phi_prompt_struct *para);
int text_area_P(phi_prompt_struct *para);

