/*
Warning: PLEASE DO NOT REMOVE THIS COMMENT WHEN REDISTRIBUTING!
This is the second official release of the Phi-prompt TUI (text user interface), library version 20110523
Released for Phi-1 and Phi-2 shields for Arduino
User is encouraged to obtain a Phi shield or is solely responsible for converting it to work on other shields or configurations.

Programmed by Dr. John Liu
Revision: 05/23/2011
Free software for educational and personal uses.
No warrantee!
Commercial use without authorization is prohibited.

Obtain the documentation or find details of the phi_prompt TUI library, Phi-1 shield, Phi-2 shield, and Phi-prompt or contact Dr. Liu at
http://liudr.wordpress.com/phi-1-shield/
http://liudr.wordpress.com/phi-2-shield/
http://liudr.wordpress.com/phi_prompt/
All rights reserved.

Summary:
This is part of the 523 release of phi_prompt for phi-2 shields. Please refer to the ducomentation at http://liudr.wordpress.com/phi_prompt.
*/

/*
.______    __    __   __        .______   .______        ______   .___  ___. .______   .___________.
|   _  \  |  |  |  | |  |       |   _  \  |   _  \      /  __  \  |   \/   | |   _  \  |           |
|  |_)  | |  |__|  | |  |       |  |_)  | |  |_)  |    |  |  |  | |  \  /  | |  |_)  | `---|  |----`
|   ___/  |   __   | |  |       |   ___/  |      /     |  |  |  | |  |\/|  | |   ___/      |  |     
|  |      |  |  |  | |  |       |  |      |  |\  \----.|  `--'  | |  |  |  | |  |          |  |     
| _|      |__|  |__| |__|  _____| _|      | _| `._____| \______/  |__|  |__| | _|          |__|     

 _______  .______                 __       __   __    __  
|       \ |   _  \               |  |     |  | |  |  |  | 
|  .--.  ||  |_)  |              |  |     |  | |  |  |  | 
|  |  |  ||      /               |  |     |  | |  |  |  | 
|  '--'  ||  |\  \----.    __    |  `----.|  | |  `--'  | 
|_______/ | _| `._____|   (__)   |_______||__|  \______/  

http://liudr.wordpress.com
*/

//#define phi_1_shield
#define phi_2_shield

#define lcd_rows 4
#define lcd_columns 20

#include <LiquidCrystal.h>
#include <WProgram.h>
#include <Wire.h>
#include <stdio.h>
#include <avr/pgmspace.h>
#include <EEPROM.h>
#include "defs.h"
#include "progmem.h"
#include <phi_buttons.h>
#include <phi_prompt.h>

LiquidCrystal lcd(LCD_RS,LCD_EN,LCD_D4,LCD_D5,LCD_D6,LCD_D7); // Create the lcd object

phi_buttons *btns[]={&btn_1,&btn_2,&btn_3,&btn_4,&btn_5,&btn_6}; // Actual buttons definitions are in the defs.h
// There are many options to use buttons. You can choose to use all 6 buttons, use 5, 4, 3, 2, or even 1 button to accomplish any inputs.
// The more buttons you use, the more convenient it is. The less buttons you use, the more pins you save.
// Please read defs.h for more details of how to use these scenarios.

// Setting up two menus top and sub_1

void setup()
{
  lcd.begin(lcd_columns, lcd_rows);
  init_phi_prompt(&lcd,btns,lcd_columns, lcd_rows, '~'); // Supply the liquid crystal object and the phi_buttons objecst. Also supply the column and row of the lcd, and indicator as '>'. You can also use '\x7e', which is a right arrow.
// Set the two channels to output to drive the buzzer and LED.
  pinMode(buzzer,OUTPUT);
  digitalWrite(buzzer,LOW);

  show_credit();
}

void loop()
{
// A two-level menu using two lists, one for top menu and one for a sub menu. Create any level of menu you like.
/*
.___  ___.  _______ .__   __.  __    __  
|   \/   | |   ____||  \ |  | |  |  |  | 
|  \  /  | |  |__   |   \|  | |  |  |  | 
|  |\/|  | |   __|  |  . `  | |  |  |  | 
|  |  |  | |  |____ |  |\   | |  `--'  | 
|__|  |__| |_______||__| \__|  \______/  
*/
  top_menu(); // See Example_menu.pde
}

void show_credit()
{
  // Display credits
  phi_prompt_struct myLongMsg;

  lcd.clear();
  lcd.noBlink();
  center_text("Credits"); // Prompt user for input. Use center_text to display center-aligned.
  myLongMsg.ptr.msg_P=msg_00; // Assign the address of the text string to the pointer.
  myLongMsg.low.i=0; // Default text starting position. 0 is highly recommended.
  myLongMsg.high.i=strlen_P(msg_00); // Position of the last character in the text string, which is size of the string - 1.
  myLongMsg.step.c_arr[0]=lcd_rows-1; // rows to auto fit entire screen
  myLongMsg.step.c_arr[1]=lcd_columns-1; // one col list
  myLongMsg.col=0; // Display the text area starting at column 0
  myLongMsg.row=1; // Display the text area starting at row 0
  myLongMsg.option=1; // Option 0, display classic message, option 1, display message with scroll bar on right.

  text_area_P(&myLongMsg);
}


