/*
Warning: PLEASE DO NOT REMOVE THIS COMMENT WHEN REDISTRIBUTING!
This is the second official release of the Phi-prompt TUI (text user interface), library version 20110523
Released for Phi-1 and Phi-2 shields for Arduino
User is encouraged to obtain a Phi shield or is solely responsible for converting it to work on other shields or configurations.

Programmed by Dr. John Liu
Revision: 05/23/2011
Free software for educational and personal uses.
No warrantee!
Commercial use without authorization is prohibited.

Obtain the documentation or find details of the phi_prompt TUI library, Phi-1 shield, Phi-2 shield, and Phi-prompt or contact Dr. Liu at
http://liudr.wordpress.com/phi-1-shield/
http://liudr.wordpress.com/phi-2-shield/
http://liudr.wordpress.com/phi_prompt/
All rights reserved.

Summary:
This is part of the 523 release of phi_prompt for phi-2 shields. Please refer to the ducomentation at http://liudr.wordpress.com/phi_prompt.

*****This version is for 16X2 displays. To use it on a different sized display, change values of lines 38 and 39.***** 

*/

// Enter a string with phi_prompt for Arduino Phi-2 shield:
/*
     _______.___________..______       __  .__   __.   _______ 
    /       |           ||   _  \     |  | |  \ |  |  /  _____|
   |   (----`---|  |----`|  |_)  |    |  | |   \|  | |  |  __  
    \   \       |  |     |      /     |  | |  . `  | |  | |_ | 
.----)   |      |  |     |  |\  \----.|  | |  |\   | |  |__| | 
|_______/       |__|     | _| `._____||__| |__| \__|  \______| 

http://liudr.wordpress.com
*/

#define lcd_rows 2
#define lcd_columns 16

//Phi-2 shield buttons
#define btn_u 5
#define btn_d 10
#define btn_l 11
#define btn_r 4
#define btn_b 14
#define btn_a 15

//Phi-2 shield LCD pin setting
#define LCD_RS 8
#define LCD_EN 9
#define LCD_D4 7
#define LCD_D5 6
#define LCD_D6 2
#define LCD_D7 3

#include <LiquidCrystal.h>
#include <WProgram.h>
#include <phi_buttons.h>
#include <phi_prompt.h>

phi_buttons btn_1(btn_u, LOW);
phi_buttons btn_2(btn_d, LOW);
phi_buttons btn_3(btn_l, LOW);
phi_buttons btn_4(btn_r, LOW);
phi_buttons btn_5(btn_b, LOW);
phi_buttons btn_6(btn_a, LOW);

LiquidCrystal lcd(LCD_RS,LCD_EN,LCD_D4,LCD_D5,LCD_D6,LCD_D7); // Create the lcd object

phi_buttons *btns[]={&btn_1,&btn_2,&btn_3,&btn_4,&btn_5,&btn_6}; // Actual buttons definitions are in the defs.h

void setup()
{
  lcd.begin(lcd_columns, lcd_rows);
  init_phi_prompt(&lcd,btns,lcd_columns, lcd_rows, '~'); // Supply the liquid crystal object and the phi_buttons objecst. Also supply the column and row of the lcd, and indicator as '>'. You can also use '\x7e', which is a right arrow.
}

void loop()
{
  int result;
  phi_prompt_struct myTextInput; // This is the structure you will use to invoke library function input_panel.

  char file_name[]="AAAAAAAA.TXT"; // This is the buffer that will store the content of the text panel. 
  myTextInput.ptr.msg=file_name; // Assign the text buffer address
  myTextInput.low.c='A'; // Text panel valid input starts with character 'A'.
  myTextInput.high.c='Z'; // Text panel valid input ends with character 'Z'.
  myTextInput.width=12; // Length of the input panel is 12 characters.
  myTextInput.col=2; // Display input panel at column 2
  myTextInput.row=1; // Display input panel at row 1
  myTextInput.option=1; // Option 1 incluess 0-9 as valid characters. Option 0, default, option 1 include 0-9 as valid inputs.
  lcd.clear(); // Clear the lcd
  lcd.print("File name:"); // Prompt user for input

  if (input_panel(&myTextInput)!=-1) // input_panel stores user choice in file_name.
  {  
    lcd.clear();
    lcd.print("Your choice was:"); // Display the user choice one more time
    lcd.setCursor(0,1); // Display the list at column 2 row 1.
    lcd.print(file_name); // Recall the text entered by the user.
  }
  else 
  {
    lcd.clear();
    lcd.print("You pressed ESC");
  }
  wait_on_escape(4000);
}
  
